package com.parkerriver;

import java.io.IOException;
import java.io.StringWriter;
import javax.servlet.*;
import javax.servlet.http.*;
import org.w3c.dom.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.apache.xerces.jaxp.DocumentBuilderFactoryImpl;
import org.apache.xml.serialize.XMLSerializer;
import org.apache.xml.serialize.OutputFormat;

import com.google.soap.search.*;

public class GoogleServlet extends HttpServlet{
    private static String KEY = "5W1JDZyzPSyI3rIa5Pt3DtXMatsniSGB";
    //tag names for google result sub-sets
    private static final String ROOT_TAG      = "search_results";
    private static final String RESULT_TAG      = "result_element";
    private static final String SUMMARY_TAG      = "summary";
    private static final String TITLE_TAG      = "title";
    private static final String URL_TAG       = "url";
    private static final String SNIPPET_TAG    = "snippet";
    private static final String DIRECTORY_TITLE_TAG    = "directory_title";

    private Document doc        = null;

    protected void doGet(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws ServletException, IOException {
        doPost(httpServletRequest,httpServletResponse);
    }

    protected void doPost(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws ServletException, IOException {
        String query = httpServletRequest.getParameter("query");
        GoogleSearch srch = new GoogleSearch();
        GoogleSearchResultElement[] results = null;
        srch.setKey(KEY);
        StringBuffer buff = null;

        try {

            //Create a XML Document
            DocumentBuilderFactory dFactory =
                    DocumentBuilderFactoryImpl.newInstance();
            DocumentBuilder builder = dFactory.newDocumentBuilder();
            doc = builder.newDocument();
        } catch(Exception e) {
            System.out.println("Exception while generating document " + e);
            doc = null;
        }

        try{
            srch.setQueryString(query);
            GoogleSearchResult rez = srch.doSearch();
            results=rez.getResultElements();
            Element rootTag = null;
            if(results != null) {
                rootTag=doc.createElement(ROOT_TAG);
                doc.appendChild(rootTag);
                for(int i = 0; i < results.length; i++)  {
                    //add each result to document using DOM
                    addResultToXML(results[i],rootTag);

                }

                httpServletResponse.setContentType("text/xml; charset=UTF-8");
                httpServletResponse.getWriter().write(xmlToString());
                // httpServletResponse.getWriter().write(rez.toString());
            }

        } catch(GoogleSearchFault f)   {
            httpServletResponse.getWriter().write(f.toString());
        }

    }
    private void addResultToXML(GoogleSearchResultElement result,Element root){
        Element resultT =  doc.createElement(RESULT_TAG);
        Element el = null;
        el = doc.createElement(SUMMARY_TAG);
        el.appendChild(doc.createTextNode(result.getSummary()));
        resultT.appendChild(el);

        el = doc.createElement(TITLE_TAG);
        el.appendChild(doc.createTextNode(result.getTitle()));
        resultT.appendChild(el);

        el = doc.createElement(URL_TAG);
        el.appendChild(doc.createTextNode(result.getURL()));
        resultT.appendChild(el);

        el = doc.createElement(SNIPPET_TAG);
        el.appendChild(doc.createTextNode(result.getSnippet()));
        resultT.appendChild(el);

        el = doc.createElement(DIRECTORY_TITLE_TAG);
        el.appendChild(doc.createTextNode(result.getDirectoryTitle()));
        resultT.appendChild(el);

        root.appendChild(resultT);
    }

    private String xmlToString(){
        StringWriter  writer    = null;
        XMLSerializer serializer   = null;
        OutputFormat  outF    = null;
        String xml = null;

        try {
            serializer = new XMLSerializer();
            writer = new StringWriter();
            outF = new OutputFormat();

            outF.setEncoding("UTF-8");
            outF.setVersion("1.0");


            // Define a Writer
            serializer.setOutputCharStream(writer);

            // Apply the format settings
            serializer.setOutputFormat(outF);

            // Serialize XML Document
            serializer.serialize(doc);
            xml = writer.toString();
            writer.close();
            return xml;

        } catch (IOException io) {
            System.out.println("Exception " + io);
        }
        return "";
    }
    private String replace(String source)   {
        /*Thanks to this site: http://weblogs.asp.net/rosherove/archive/2003/05/13/6963.aspx*/
        return source.replaceAll("<(.+)*?>","");
    }
}
