package com.parkerriver;

import java.util.*;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
/**
 * Created by IntelliJ IDEA.
 * User: bruceperry
 * Date: Oct 19, 2005
 * Time: 9:23:17 AM
 * To change this template use File | Settings | File Templates.
 */
public class SportChoiceServlet extends HttpServlet {
    private static Map TEAM_SPORTS;
    private static Map IND_SPORTS;
    static{
        TEAM_SPORTS =  Collections.synchronizedMap(new HashMap());
        TEAM_SPORTS.put("baseball",new Integer(0));
        TEAM_SPORTS.put("basketball",new Integer(0));
        TEAM_SPORTS.put("football",new Integer(0));
        TEAM_SPORTS.put("hockey",new Integer(0));
        TEAM_SPORTS.put("tennis",new Integer(0));
        TEAM_SPORTS.put("soccer",new Integer(0));
        TEAM_SPORTS.put("lacrosse",new Integer(0));
        IND_SPORTS =  Collections.synchronizedMap(new HashMap());
        IND_SPORTS.put("triathlon",new Integer(0));
        IND_SPORTS.put("cycling",new Integer(0));
        IND_SPORTS.put("running",new Integer(0));
        IND_SPORTS.put("nordic_skiing",new Integer(0));
        IND_SPORTS.put("swimming",new Integer(0));
        IND_SPORTS.put("track",new Integer(0));
        IND_SPORTS.put("inline_skating",new Integer(0));

    }
    protected void doGet(HttpServletRequest httpServletRequest,
                         HttpServletResponse httpServletResponse) throws ServletException, IOException {
        /* Record the votes for team/individual sports; send back the totals updated */
        String sportTyp = httpServletRequest.getParameter("sportType");
        String choices = httpServletRequest.getParameter("choices");
        String col = httpServletRequest.getParameter("col");
        if(sportTyp != null && sportTyp.length() > 0 && choices != null &&
                choices.length() > 0){
            addVotes(sportTyp,choices);
            sendResponse(httpServletResponse,true,sportTyp);
        } else if (sportTyp != null && sportTyp.length() > 0 && col != null){
            sendResponse(httpServletResponse,false,sportTyp);
        }


    }

    protected void doPost(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws ServletException, IOException {
        doGet(httpServletRequest, httpServletResponse);
    }

    private void sendResponse(HttpServletResponse httpServletResponse,
                              boolean pollResults, String sportType) throws IOException {
        httpServletResponse.setContentType("text/plain");
        httpServletResponse.setHeader("Cache-Control", "no-cache");
        if(pollResults){
           httpServletResponse.getWriter().write(getTotals(sportType));

        }   else {
            httpServletResponse.getWriter().
                    write(AjaxUtil.
                            getJsonArray(sportType.
                            indexOf("team") != -1 ? ((String[])TEAM_SPORTS.
                            keySet().toArray(new String[]{}))  :  ((String[])IND_SPORTS.keySet().toArray(new String[]{}))));
        }
    }

    private void addVotes(String type,String choices){
        StringTokenizer toke  = new StringTokenizer(choices," ");
        String next = null;
        int intObj = 0;
        if(type.equalsIgnoreCase("team_sports")){
            //increment the sport that is part of choices
            while(toke.hasMoreElements()){
                next = toke.nextToken();
                intObj = ((Integer) TEAM_SPORTS.get(next)).intValue();
                TEAM_SPORTS.put(next,new Integer(++intObj));
            }
        }  else {

            while(toke.hasMoreElements()){
                next = toke.nextToken();
                intObj = ((Integer) IND_SPORTS.get(next)).intValue();
                IND_SPORTS.put(next,new Integer(++intObj));
            }
        }

    }
    private String getTotals(String type){
        if(type == null || type.length() == 0)  return "{Error: \"A sport type was not specified.\"}";
        Integer val=null;
        String key = null;
        Map.Entry me = null;
        StringBuffer buf = new StringBuffer("");
        int sz = 0;
        int inc = 0;
        if(type.equalsIgnoreCase("team_sports")){
            sz = TEAM_SPORTS.size();
            for(Iterator iter= TEAM_SPORTS.entrySet().iterator();iter.hasNext();)  {
                me=(Map.Entry) iter.next();
                key = ((String)me.getKey());
                val= ((Integer)me.getValue());
                buf.append(key).append(",").append(val.intValue());
                if(++inc < sz) { buf.append(",");}

            }
        } else {
            sz = IND_SPORTS.size();
            for(Iterator iter= IND_SPORTS.entrySet().iterator();iter.hasNext();)  {
                me=(Map.Entry) iter.next();
                key = ((String)me.getKey());
                val= ((Integer)me.getValue());
                buf.append(key).append(",").append(val.intValue());
                if(++inc < sz) { buf.append(",");}

            }

        }
            return AjaxUtil.getJsonFormat(buf.toString(),",");
    }
}
